#include <audacious/util.h>
#include <audacious/configdb.h>

#include <glib.h>
#include <glib/gi18n.h>

#include "config.h"

void
hatena_about_show(void)
{
	static GtkWidget *aboutbox;
	gchar *tmp;

	if (aboutbox) return;

	tmp = g_strdup_printf("Audacious Hatena Plugin\n\n"
						  "Originally created by Audun Hove <audun@nlc.no> "
						  "and Pipian <pipian@pipian.com>\n"
						  "Refined by nosuke <sasugaanija@gmail.com>");
	aboutbox = xmms_show_message(_("About Hatena Plugin"),
								 _(tmp),
								 _("Ok"), FALSE, NULL, NULL);

	g_free(tmp);
	gtk_signal_connect(GTK_OBJECT(aboutbox), "destroy",
					   GTK_SIGNAL_FUNC(gtk_widget_destroyed), &aboutbox);
}


void
hatena_errorbox_show(char *errortxt)
{
	gdk_threads_enter();

	xmms_show_message("Hatena Error",
					  errortxt,
					  _("OK"), TRUE, NULL, NULL);

	gdk_threads_leave();
}
