#ifndef NET_H
#define NET_H 1

typedef enum {
	NOT_RUNNING = 0,
	HS_EMPTY_BODY,          /* Response from server has no message body */
	HS_SERVER_FAILED,       /* Server returned an error */
	HS_UPDATE_PLUGIN,       /* Plugin must be updated */
	/*HS_NOINTERVAL,*/          /* Server didn't return transaction interval */
	HS_BROKEN_RESPONSE,     /* Handshake response is broken */
	HS_OK,                  /* Handshake OK */
	HS_BADUSERNAME,         /* not found user ID in server */
	HS_UNKNOWN_ERROR,
	HS_NOUSERNAME,          /* username is empty */
	HS_NOPASSWORD,          /* passwword is empty */
	HS_CURL_CONNECT,
	HS_CURL_ERROR,
	SB_EMPTY_BODY,
	SB_OK,
	SB_BADAUTHENTICATON_1ST,
	SB_BADAUTHENTICATON,
	SB_SERVER_FAILED,
	SB_CURL_CONNECT,
	SB_CURL_ERROR,
	SB_UNKNOWN_ERROR
} sc_status_code;


typedef struct {
	char *artist;
	char *title;
	char *mb;
	char *album;
	char *utctime;
	char len[16];
} sc_entry_t;


int hatena_idle(void);
void hatena_init(void);
void hatena_init_cache(char *);

void hatena_reset_params(void);
void hatena_set_username(char *);
void hatena_set_password(char *);
void hatena_set_proxy(int, char *, char *, int,  char *, char *);

int hatena_add_entry(char *, char *, time_t, char *, char *, int);

void hatena_cleaner(void);

sc_status_code hatena_get_status(void);
CURLcode hatena_get_curl_status(void);

void hatena_set_status_handler(void (* status_handler) (sc_status_code));

void hatena_set_cachefile(const char *);
int hatena_get_next_hs(void);
int hatena_get_next_sb(void);


#endif
