#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curl/curl.h>
#include "queue.h"

static queue_item_t *sc_queue_head = NULL;
static queue_item_t *sc_queue_tail = NULL;
static int sc_queue_nitems = 0;


int
hatena_queue_len(void)
{
	return sc_queue_nitems;
}


void
hatena_queue_push(void *entry)
{
	queue_item_t *item;

	item = (queue_item_t *)malloc(sizeof(queue_item_t));
	item->entry = entry;
	item->next = NULL;

	sc_queue_nitems ++;

	if (sc_queue_head == NULL) {
		sc_queue_head = sc_queue_tail = item;
	} else {
		sc_queue_tail->next = item;
		sc_queue_tail = item;
	}
}


void *
hatena_queue_pull(void)
{
	queue_item_t *item;
	void *ret;

	if (sc_queue_nitems == 0)
		return NULL;
	
	item = sc_queue_head;

	if(item == NULL)
		return NULL;

	ret = item->entry;

	sc_queue_head = sc_queue_head->next;

	sc_queue_nitems --;

	if (sc_queue_nitems == 0)
		sc_queue_tail = NULL;

	free(item);

	return ret;
}


static void *
hatena_queue_peek_all_x(int rewind)
{
	static queue_item_t *citem = NULL;
	queue_item_t *temp_item;

	if (rewind) {
		citem = sc_queue_head;
		return NULL;
	} 

	if (citem == NULL)
		return NULL;

	temp_item = citem;
	citem = citem->next;
	return temp_item->entry;

}


void *
hatena_queue_peek_all(void)
{
	return hatena_queue_peek_all_x(0);
}



void
hatena_queue_peek_all_rewind(void)
{
	hatena_queue_peek_all_x(1);
}


void *
hatena_queue_peek(void)
{
	if (sc_queue_nitems == 0)
		return NULL;

	return sc_queue_head->entry;
}

